unit Unit8;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCLTee.TeEngine, VCLTee.Series,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, Vcl.StdCtrls;

type
  TMyChart = class( TPanel )
    constructor Create( AOwner : TComponent ); override;
  PRIVATE
    FChart : TChart;
  PUBLISHED
    property Chart : TChart
               read FChart;
  end;



  TForm8 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    FMyChart : TMyChart;
  public
    { Public declarations }
  end;

var
  Form8: TForm8;

implementation

{$R *.dfm}

uses
  ShlObj;


function GetSpecialFolderPath( ASpecialFolder:Integer ):String;
// returns a windows special folder
var
  PIDL       : PItemIDList;
  FolderPath : array[0..MAX_PATH] of Char;
begin

  { get our special folder location }
  SHGetSpecialFolderLocation(
    0,
    ASpecialFolder,
    PIDL);

  { convert our special folder location to a string}
  SHGetPathFromIDList(
    PIDL,
    FolderPath);

  { return our special folder location as a string }
  Result := FolderPath;
end;




procedure SaveComponentToFile( AComponent : TComponent );
var
  MS : TMemoryStream;
  SS : TStringStream;
begin
  MS := TMemoryStream.Create;
  SS := TStringStream.Create;
  try
    MS.WriteComponent( AComponent );
    MS.Position := 0;
    ObjectBinaryToText( MS, SS );
    SS.SaveToFile( GetSpecialFolderPath( CSIDL_DESKTOP ) + '\test.txt' );
  finally
    MS.Free;
    SS.Free;
  end;
end;


procedure LoadComponentFromFile( var AComponent : TComponent );
var
  MS : TMemoryStream;
  SS : TStringStream;
  Component : TComponent;
begin
  MS := TMemoryStream.Create;
  SS := TStringStream.Create;
  try
    SS.LoadFromFile( GetSpecialFolderPath( CSIDL_DESKTOP ) + '\test.txt' );
    SS.Position := 0;
    ObjectTextToBinary( SS, MS );
    MS.Position := 0;
    Component := MS.ReadComponent( AComponent );
    AComponent := Component;
  finally
    MS.Free;
    SS.Free;
  end;
end;



procedure TForm8.Button1Click(Sender: TObject);
begin
  FMyChart.FChart.Color := clGreen;
end;

procedure TForm8.Button2Click(Sender: TObject);
begin
  SaveComponentToFile( FMyChart );
end;

procedure TForm8.Button3Click(Sender: TObject);
begin
  LoadComponentFromFile( TComponent(FMyChart) );
end;

procedure TForm8.FormCreate(Sender: TObject);
begin
  FMyChart := TMyChart.Create( Self );
  FMyChart.Name := 'Mychart1';
  FMyChart.Parent := Self;
end;

{ TMyChart }

constructor TMyChart.Create(AOwner: TComponent);
begin
  inherited;
  Width := 400;
  Height := 150;
  FChart := TChart.Create( Self );
  FChart.Parent := Self;
  FChart.Align := alClient;
  FChart.AddSeries( TLineSeries.Create( FChart ));
  FChart.Series[0].FillSampleValues(100);
end;

initialization

  RegisterClass( TMyChart );
  RegisterClass( TChart );
  RegisterClass( TLineSeries );

end.
